<template>
    <div class="q-gutter-y-lg full-width">

        <q-select
            :options="FloorChartType"
            emit-value
            map-options
            label-slot
            filled
            :value="value.type"
            @input="Input('type', $event)"
        >
            <template v-slot:label>
                <LabelSlot icon="icofont-dashboard-web" label="Chart Type"
                           tooltip="The chart to type to visualize the analytics"/>
            </template>

            <template v-slot:option="scope">
                <q-item v-bind="scope.itemProps" v-on="scope.itemEvents">
                    <q-item-section avatar>
                        <q-icon :name="scope.opt.icon"/>
                    </q-item-section>
                    <q-item-section>
                        <q-item-label>
                            {{ scope.opt.label }}
                        </q-item-label>
                    </q-item-section>
                </q-item>
            </template>
        </q-select>
        <q-select
            :options="FloorValueType"
            emit-value
            filled
            map-options
            label-slot
            :value="value.valueType"
            @input="Input('valueType', $event)"
        >
            <template v-slot:label>
                <LabelSlot icon="icofont-speed-meter" label="Metric"
                           tooltip="The metric used to compute the analytics"/>
            </template>
        </q-select>
        <q-select
            :options="FloorVariable"
            emit-value
            filled
            map-options
            label-slot
            :value="value.independent"
            @input="Input('independent', $event)"
        >
            <template v-slot:label>
                <LabelSlot icon="icofont-chart-arrows-axis" label="Graph Axis"
                           tooltip="The axes of data you want to visualize"/>
            </template>
        </q-select>
        <q-select
            :value="value.trades"
            @input="Input('trades', $event)"

            :options="Trades" label-slot multiple use-chips use-input filled>
            <template v-slot:label>
                <LabelSlot icon="icofont-wrench" label="Worker Trade Filter"
                           tooltip="Filter by trades (leave empty for no filter)"/>
            </template>
        </q-select>
        <q-toggle label="Merge" icon="call_merge"
                  :value="value.merge"
                  @input="Input('merge', $event)" v-if="ShowMerge"/>
        <QSelect v-if="value.type === 'line'"
                 filled
                 :value="value.scope"
                 @input="Input('scope', $event)"
                 label-slot
                 emit-value
                 map-options
                 :options="ChartScopeType">
            <template v-slot:label>
                <LabelSlot icon="icofont-clock-time" label="Time Scope"
                           tooltip="How narrow to divide time intervals"/>
            </template>
        </QSelect>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import FormCore from "components/FormCore.vue";
import {
    FloorChartValueType,
    FloorChartVariableType,
    FloorGraphType,
    GraphScope,
    GraphScopeType
} from "src/classLibrary/Charting/FloorChart";
import LabelSlot from "components/LabelSlot.vue";
import {DeepClone} from "src/classLibrary/Utility";

export interface FloorChartOptionsWidgetInterface {
    type: FloorGraphType,
    independent: FloorChartVariableType,
    valueType: FloorChartValueType,
    merge: boolean,
    scope?: GraphScope,
    trades?: string[],
}

@Component({
    components: {LabelSlot, FormCore}
})
export default class FloorChartOptions extends Vue {
    @Prop() value!: FloorChartOptionsWidgetInterface;
    @Prop() days!: string[];

    get ShowMerge() {
        const t = this.value.type;
        return t !== 'line' && t != 'radar';
    }

    Input(key: string, value: any) {
        const v = DeepClone(this.value) as any
        v[key] = value;
        this.$emit('input', v)
    }

    get FloorChartType() {
        return FloorGraphType;
    }

    get FloorVariable() {
        return FloorChartVariableType;
    }

    Trades: string[] = []

    async init() {
        const projectId = this.PersistentStore.StoreValue.project;
        const token = await this.$auth.CoreToken;

        const r = await this.$coreApi.Get<string[]>(`Worker/trades/${projectId}`, null, token);
        if (r.isErr()) return;
        this.Trades = r.unwrap();
    }


    get FloorValueType() {
        return FloorChartValueType;
    }

    get ChartScopeType() {
        return GraphScopeType;
    }

}
</script>

<style lang='scss' scoped>

</style>
